
#include <ESP32Servo.h>
#include <Wire.h>
// THIS IS FOR SMALL SERVO

//#define POT PIN_PA6 //potentiometer
//#define PSERVO PIN_PA7 //servo

#define HeatSwitch A3 //resistive heating switch

// 2 servo objects. we will use servo1 as the gripper. servo2 is the sticks
Servo servo1;
Servo servo2; 
//servo pins
const int S1 = D0;
const int S2 = D1;

bool s1_init = false;
bool s2_init = false;

//
const int Addr = 16; //i2c addr
float myAddr = 16;

float thetaDes1 = 0;
float thetaDes2 = 0;

//int curPot;
//float curTheta;

const byte bufSize = 6;
char buf[bufSize];

bool attachA = false;

int HeatInterval = 1000;

//bool initialized = false;

const int LEDPIN = LED_BUILTIN;
bool LEDON = false;

//Serial parsing stuff. 

boolean newData = false;
const byte numChars = 32;
char recievedChars[numChars];
char tempChars[numChars];

int boardAddress = 0;
float desTheta = 0.0;
char cmdType[numChars] = {0};

//float-string converter
union FSconverter {
    char buffer[4];
    float FSfloat;
  } FSconvert;
union FSconverter2 {
    char buffer[4];
    float FSfloat2;
  } FSconvert2;
//float-string for attach converter
union ISconverter {
  char buffer[4];
  float ISint;
} ISconvert;


////declare servo object
//Servo actuator;

void setup()
{
    //i2c
    Wire.begin(Addr); //address, use 8+
    Wire.onReceive(receiveEvent);
    Wire.onRequest(requestEvent);

    Serial.begin(115200);
    Serial.println("initializing");
    Serial.print("my addr: ");
    Serial.println(Addr);
    //Servo
//    actuator.attach(PSERVO);
//    //Feedback line
//    pinMode(POT, INPUT); 
    pinMode(HeatSwitch, OUTPUT);

    pinMode(LEDPIN, OUTPUT);
    digitalWrite(LEDPIN, LOW); //active low.
//    actuator.writeMicroseconds(1500);//midpoint --1500
    
    //Heater
    digitalWrite(HeatSwitch, 0);

    //little delay
    delay(5);
//    servo1.attach(S1);
//    servo2.attach(S2);
    
}

void loop()
{
  SerialRoutine();
  //check if we want to attach new module
  if (attachA == true){
    attachActuator(HeatInterval);
    attachA=false;
  }
//  servo1.write(100);
//  servo2.write(50);
  //Write the desired value to the servo.
  if (s1_init){
    servo1.writeMicroseconds(thetaToMicroseconds(thetaDes1));
  }
  if (s2_init){
    servo2.writeMicroseconds(thetaToMicroseconds(thetaDes2));
  }
}

void getSerialData(){
  while (Serial.available()>0 && newData == false){
    //uint8_t buf[1];
    //Serial.readBytes[buf, 1];
    
    char B = Serial.read();
    //Serial.println(B);
    static boolean recvInProgress = false;
    static byte j = 0;
    char startMarker = '<';
    char endMarker = '>';
    //char rc;

    if (recvInProgress == true){
      if (B != endMarker){
        recievedChars[j] = B;
        j++;
        if (j>=numChars){
          j=numChars-1;
        }
      }
      else {
        recievedChars[j] = '\0';
        recvInProgress = false;
        j = 0;
        newData = true;
      }
    }
    else if (B == startMarker){
      recvInProgress = true;
    }
  }
}

void parseSerialData(){
  char * strtokIndx; // this is used by strtok() as an index

  strtokIndx = strtok(tempChars,",");      // get the first part - the string
  strcpy(cmdType, strtokIndx); // copy it to messageFromPC

  strtokIndx = strtok(NULL, ","); // this continues where the previous call left off
  boardAddress = atoi(strtokIndx);     // convert this part to an integer

  strtokIndx = strtok(NULL, ",");
  desTheta = atof(strtokIndx);     // convert this part to a float
}

void sendToI2C(){
  char B = cmdType[0];
  if (boardAddress == Addr){
    // do our things
    if (B == 'G'){
      //gripper
      thetaDes1 = desTheta; // write the desired theta to the servo
      Serial.println(thetaToMicroseconds(thetaDes1));
      if (s1_init == false){
      servo1.attach(S1); // initial servo1 
      s1_init = true;
      Serial.println("attaching S1");
    }
    }
    else if (B == 'P'){
      //other servo
      thetaDes2 = desTheta; // write the desired theta to the servo2
      Serial.println(thetaToMicroseconds(thetaDes2));
      if (s2_init == false){
      servo2.attach(S2); // initial servo1 
      s2_init = true;
      Serial.println("attaching S2");
    }
    }
    else if (B == 'A'){
      //attach
      HeatInterval = int(1000*desTheta);
      attachA = true;
      Serial.println("A");
    }
    else if (B == 'E'){
      Serial.println(Addr);
    }
    else{
      Serial.println("unrec");
    }
  }
  else{
    Serial.println("not permitted");
  }
}

void SerialRoutine(){
  getSerialData();
  if (newData == true){
    strcpy(tempChars, recievedChars);
    parseSerialData();
    sendToI2C();
    newData = false;
  }
}

void receiveEvent(int){
  //M means update thetaDes, A means attach new actuator
  static byte ndx=0;
  char rc;
  
  while (Wire.available()>0){
    rc = Wire.read();
    //Serial.println(rc);
    buf[ndx] = rc;
    ndx++;
    if (ndx >= bufSize){
      //prevent accidental overflow
      ndx = bufSize - 1;
    }
  }
  ndx = 0;
  Serial.println(buf[0]);
  if (buf[0]=='G'){
    // Move to new theta
    for (int i = 1; i <= 4; i++){
      FSconvert.buffer[i-1] = buf[i];
    }
    
    thetaDes1 = FSconvert.FSfloat;
    //gripper
//    thetaDes1 = desTheta; // write the desired theta to the servo
      Serial.println(thetaToMicroseconds(thetaDes1));
      if (s1_init == false){
      servo1.attach(S1); // initial servo1 
      s1_init = true;
      Serial.println("attaching S1");
    }
//    actuator.attach(PSERVO);
//    initialized = true;
    
//    Serial.println(thetaToMicroseconds(thetaDes1));
//      if (s1_init == false){
//      servo1.attach(S1); // initial servo1 
//      s1_init = true;
//      Serial.println("attaching S1");
//  }
  }
  if (buf[0]=='P'){
    // Move to new theta
    for (int i = 1; i <= 4; i++){
      FSconvert.buffer[i-1] = buf[i];
    }
    
    thetaDes2 = FSconvert.FSfloat;
//    actuator.attach(PSERVO);
//    initialized = true;
//thetaDes2 = desTheta; // write the desired theta to the servo2
      Serial.println(thetaToMicroseconds(thetaDes2));
      if (s2_init == false){
      servo2.attach(S2); // initial servo1 
      s2_init = true;
      Serial.println("attaching S2");
    }
    
//    Serial.println(thetaToMicroseconds(thetaDes2));
//      if (s2_init == false){
//      servo2.attach(S2); // initial servo2
//      s2_init = true;
//      Serial.println("attaching S2");
//  }
  }
  
  if (buf[0]=='A'){
    //attach new actuator
    for (int i = 1; i <= 4; i++){
      ISconvert.buffer[i-1] = buf[i];
    }
    HeatInterval = int(1000*ISconvert.ISint);
    attachA = true;
  }
  
}

void requestEvent(){
  //sending status/position back
  Wire.write(buf[0]);
  //write to union
  FSconvert2.FSfloat2 = myAddr;
  for (int i = 0; i<=3; i++){
    Wire.write(FSconvert2.buffer[i]);
  }
}

int thetaToMicroseconds(float thetaDes){
  int microSec;
//  float conversionFactor = 2000/3.14159265;
  float conversionFactor = 567.5465;
  float offset = 608;
  microSec = int(thetaDes * conversionFactor + offset);
  return microSec;
}

void attachActuator(int HeatInterval){
  unsigned long lastIntTime = millis();
  unsigned long intTimeNow = millis();
  //int HeatInterval = 15000; //1000 is 1 sec.
  //Set max limit. 
  Serial.println(HeatInterval);
  if (HeatInterval > 40000){
    HeatInterval = 40000;
  }
  while ((intTimeNow-lastIntTime) <= HeatInterval){
   digitalWrite(HeatSwitch, HIGH);
    intTimeNow = millis();
  }
  digitalWrite(HeatSwitch, LOW);
  Serial.println("done");
  
}
