from pickle import TRUE
import websocket as ws
import numpy as np
import matplotlib.pyplot as plt
import struct
import time
import string
from cmath import nan
import csv
#from sympy import *

# from pydrake.all import (
#     DiagramBuilder, MeshcatVisualizerCpp, MeshcatVisualizerParams, 
#     Simulator, FindResourceOrThrow,
#     Parser, MultibodyPlant, RigidTransform, RollPitchYaw,
#     PiecewisePolynomial, PiecewiseQuaternionSlerp, RotationMatrix, Solve,
#     TrajectorySource, ConstantVectorSource, AddMultibodyPlantSceneGraph, SceneGraph, LinearQuadraticRegulator, 
#     Linearize, PlanarSceneGraphVisualizer,Adder, Demultiplexer, 
#     InverseDynamicsController, MakeMultibodyStateToWsgStateSystem, 
#     PassThrough, StateInterpolatorWithDiscreteDerivative, Role,
#     FixedOffsetFrame, DirectCollocation, Multiplexer, ExtractValue
# )
# from pydrake.multibody import inverse_kinematics
# from pydrake.trajectories import PiecewisePolynomial
# from pydrake.solvers.mathematicalprogram import MathematicalProgram, Solve

########################
###Robot Definitions ###
########################

cont = True

ids = [20,21,22,23,24] #i2c addresses for actuators
# ids = [10,11,12,13,14,15,16,17]
mids = [20,21,22,23,24]
fids = [15,16]
gripper_amt = 0 #how many grippers (to exclude from M)

numActuatorHE = struct.pack("!B",len(mids)) #str(len(ids)).encode('utf-8')
numActuatorM = struct.pack("!B",(len(mids)-gripper_amt))#str(len(ids)-gripper_amt).encode('utf-8')

idsBytes = b""
for i in ids:
    idsBytes = idsBytes + struct.pack("!B", int(i))

MidsBytes = b""
# for i in ids[1:(len(ids)-1)]:
#     MidsBytes = MidsBytes + struct.pack("!B", int(i))
for i in mids:
    MidsBytes = MidsBytes + struct.pack("!B", int(i))

position0 = np.array([-0.002, 4.734, 10.0, -1.997, 10.0, 0.316, 6.2])#np.array([0,1.55,1.68,1.52,1.52,1.48,1.65,0]) #zero position (i.e., all vertical)

#offsets = [[0,0,0,-np.pi/2,-np.pi/2,0,0,0],[0,0,0,0,0,0,0,0]] #preset offsets. 
offset = np.array([-0.002, 4.734, 10.0, -1.997, 10.0, 0.316, 6.2]) # this is vertical. 

curPos = [0,0,0,2,0,0] # current position in voxel space xyz foot 1, xyz foot2.
desPos = [0,0,0,2,0,0] # desired position in voxel space.

nextStep = np.zeros(6) # Next move. format is [x,y,z,rot_x,rot_y,rot_z]

priorStep = [False, 0, curPos] # have we moved yet?

# addr = "ws://192.168.1.126"#"ws://192.168.1.113" #"ws://192.168.1.107" #birdi0 ESP32 IP address
addr = "ws://192.168.1.144" #assembler
# addr = "ws://192.168.1.142" #assembler
# 192.168.1.126
# addr = "ws://192.168.8.111"

esp32 = ws.WebSocket()

delay = 0.1

esp32.connect(addr)

#################
### Main Loop ###
#################

def parse_input(inputs, position0, priorStep):

    cont = True
    inputs = inputs.translate({ord(c): None for c in string.whitespace})
    inputs = inputs.split(",")
    #global priorStepped
    knots = 24 # interp amount... it's not a knot lol
    #print(inputs)
    if len(inputs) > 1:
        #print(len(inputs))
        for inp in inputs:
            cont = parse_input(inp, position0, priorStep)
        return cont
    else:
        inp = inputs[0]    

    def getTrajectories(frames,tk):
        """ 
        frames: list of numpy arrarys of the key frames.
        tk: list of the breaktimes for each key frame
        returns: 
        x_values_forward, x_values_reverseed, x_values_forward_B, x_values_reversed_B
        """

        assert len(tk)==len(frames), "lengths of frames and tk must match"

        x_trajectory = PiecewisePolynomial.FirstOrderHold(tk, np.column_stack(frames))
                        
        knots = 24 # interpolation amount
        times = np.linspace(x_trajectory.start_time(), x_trajectory.end_time(), knots)

        x_values_forward = x_trajectory.vector_values(times) #size: actuator amt pos, velocity, by knot amount.
        x_values_reversed_B = np.flip(x_values_forward)

        x_values_reversed = np.zeros(((len(mids)-gripper_amt),knots))
        x_values_forward_B = np.zeros(((len(mids)-gripper_amt),knots))

        for i in range((len(mids)-gripper_amt)):
                            x_values_reversed[i][:] = np.flip(x_values_forward[i])
                            x_values_forward_B[i][:] = np.flip(x_values_reversed_B[i])

        return x_values_forward, x_values_reversed, x_values_forward_B, x_values_reversed_B
    
    def getEuler():
        message = esp32.recv()
        euler = []
        for i in range(3):
            euler.append(round(struct.unpack("<f",message[(i*4):(i*4 + 4)])[0],3))
        esp32.recv() # it sends bonus messages 
        esp32.recv() # in fact, it sends two of them. I don't know why.
        return euler
    
    def getAccel():
        message = esp32.recv()
        accels = []
        for i in range(3):
            accels.append(round(struct.unpack("<f",message[(i*4):(i*4 + 4)])[0],3))
        # print(accels)
        esp32.recv() # 1 bonus message
        return accels
    
    if inp[0] == "A":
        inp = inp.split(":")
        boardAddress = struct.pack("!B", int(inp[1]))
        heatTime = struct.pack("!B",int(inp[2])) #inp[2].endcode('utf-8')#struct.pack("@f",float(inp[2]))
        packet = b"A" + boardAddress + heatTime
        esp32.send(packet)
        print("done")
    elif inp[0] == "Z":
        inp = inp.split(":")
        boardAddress = struct.pack("!B", int(inp[1]))
        #print(boardAddress)
        packet = b"Z" + boardAddress
        esp32.send(packet)
        print("done")
    elif inp[0] == "H":
        inp = inp.split(":")
        boardAddress = struct.pack("!B", int(inp[1]))
        #print(boardAddress)
        packet = b"H" + boardAddress
        esp32.send(packet)
        print("done")
    elif inp[0] == "M":
        inp = inp.split(":")
        boardAddress = struct.pack("!B", int(inp[1]))
        thetaDes = struct.pack("@f", float(inp[2]))
        #print(boardAddress+thetaDes)
        packet = b"M" + boardAddress + thetaDes
        esp32.send(packet)
        #print(packet)
        print("done")
    elif inp[0] == "E":
        inp = inp.split(":")
        boardAddress = struct.pack("!B", int(inp[1]))
        #request data...
        packet = b"E"+boardAddress
        esp32.send(packet)
        message = struct.unpack("<f", esp32.recv())
        print(round(message[0],3))
        print("done")
    elif inp[0] == "G":
        # inp = inp.split(":")
        #request IMU Euler orientaiton angles...
        packet = b"G"
        esp32.send(packet)
        message = esp32.recv()
        # print(message)
        euler = []
        for i in range(3):
            euler.append(round(struct.unpack("<f",message[(i*4):(i*4 + 4)])[0],3))
        print(euler)
        # mysteryVariable = esp32.recv()
        # print(mysteryVariable)
        # # print(esp32.recv())
        # print(esp32.recv())
        esp32.recv()
        esp32.recv()
        print("done")
    elif inp[0] == "X":
        #request IMU linear accelerations
        packet = b"X"
        esp32.send(packet)
        message = esp32.recv()
        # print(message)
        accels = []
        for i in range(3):
            accels.append(round(struct.unpack("<f",message[(i*4):(i*4 + 4)])[0],3))
        print(accels)
        mysteryVariable = esp32.recv()
        # print(mysteryVariable)
        print("done")
    elif inp[0] == "O":
        #request IMU quaternion
        packet = b"O"
        esp32.send(packet)
        message = esp32.recv()
        # print(message)
        quats = []
        for i in range(4):
            quats.append(struct.unpack("<f",message[(i*4):(i*4 + 4)])[0])
        print(quats)
        # mysteryVariable = esp32.recv()
        print("done")
    elif inp[0] == "L":
        inp = inp.split(":")
        LEDrepeats = struct.pack("!B", int(inp[1]))
        packet = b"L"+LEDrepeats
        esp32.send(packet)
        print(packet)
        print("done")
    elif inp[0] == "R":
        #i2c recovery method (power cycle the boards)
        #this might power cycle everyone, yikes... maybe should add a diode
        inp = inp.split(":")
        packet = b"R"
        esp32.send(packet)
        print(packet)
        print("done")

    elif inp[0] == "P":
        keepon = input("press a key to continue, or a cmd to add... ")
        if keepon == "Q":
            cont = parse_input("Q", position0, priorStep)
            return cont
        elif len(keepon)>=1:
            parse_input(keepon, position0, priorStep)
            parse_input("P",position0, priorStep)
    elif inp[0] == "C":
        inp = inp.split(":")
        if inp[1] == "H":
            packet = b"C"+b"H"+numActuatorHE+idsBytes
            #print(packet)
            esp32.send(packet)
        elif inp[1] == "E":
            if len(inp) == 2:
                Eall = []
                for i in range(len(mids)):
                    boardAddress = struct.pack("!B", mids[i])
                    packet = b"E"+boardAddress
                    esp32.send(packet)
                    message = struct.unpack("<f", esp32.recv())
                    #EConverter(boardAddress, message[0])
                    Eall.append(round(message[0],3))
                    #Eall.append(EConverter(ids[i], message[0]))
                print(Eall)
            else:
                if inp[2] == "M":
                    Eall = []
                    for i in range(len(mids)):
                        boardAddress = struct.pack("!B", mids[i])
                        packet = b"E"+boardAddress
                        esp32.send(packet)
                        message = struct.unpack("<f", esp32.recv())
                        #EConverter(boardAddress, message[0])
                        Eall.append(round(message[0],3))
                        #Eall.append(EConverter(ids[i], message[0]))
                    print(Eall)
                elif inp[2] == "F":
                    Eall = []
                    for i in range(4):
                        boardAddress = struct.pack("!B", fids[i])
                        packet = b"E"+boardAddress
                        esp32.send(packet)
                        message = struct.unpack("<f", esp32.recv())
                        #EConverter(boardAddress, message[0])
                        Eall.append(round(message[0],3))
                        #Eall.append(EConverter(ids[i], message[0]))
                    print(Eall)
                else:
                    print("unrecognized")

        elif inp[1] == "M":
            ##################
            ### MULTI-MOVE ###
            ##################

            #Get current joint positions:
            Eall = []
            validPosition = True
            for i in range(len(ids)):
                Eall_val = False
                count = 0
                while not Eall_val:
                    boardAddress = struct.pack("!B", ids[i])
                    packet = b"E"+boardAddress
                    esp32.send(packet)
                    message = struct.unpack("<f", esp32.recv())
                    if np.isnan(message[0]) == False :
                        Eall.append(round(message[0],3))
                        Eall_val = True
                    elif count > 5:
                        Eall_val = True
                        print(f"repeat E failure at {i}")
                        validPosition = False
                    else:
                        Eall_val = False
                        #print(type(message[0]))
                        count += 1
                        #print(f"E failure at '{i}' ")
            
            if validPosition == True:
                if len(inp) == 2:
                    #ORIGINAL IK BASED VERSION
                    print("og IK disabled")

                elif len(inp) > 2:
                    #these are the base frames from drake. 
                    # f000 = np.zeros(8) #flat
                    # fd = np.array([0,0,0,0,-1.55,-1.55,-1.55,-1.55]) #standing default
                    f000 = np.zeros(7) #straight up
                    f200 = np.array([ 1.05,  0.42, 0, 2.35, 0, 0.38, -5.23]) #x2, y0, z0
                    f210 = np.array([ 1.57,  0.49, 0, 2.21, 0, 0.45, -4.71])
                    f211 = np.array([ 1.57,  0.  , 0, 2.21, 0, 0.92, -4.72])
                    f212 = np.array([ 1.57, -0.23, 0, 1.98, 0, 1.38, -4.71])
                    f213 = np.array([ 1.57, -0.22, 0, 1.57, 0, 1.78, -4.71])

                    # M:12:0,M:13:0,M:14:0,M:

                    if inp[2] == "FD" or inp[2] == "DF":
                        
                        #flat to standing or standing to flat
                        ########
                        frames = [
                            f000,
                            fd
                        ]
                        x_values_forward, x_values_reversed, x_values_forward_B, x_values_reversed_B = getTrajectories(frames,tk=[0,1])
                        if inp[2] == "FD":
                            #step is x_values_forward
                            thetaDes_floats = []
                            for i in range(knots):
                                for j in range((len(mids)-gripper_amt)):
                                    thetaDes_floats.append(round((x_values_forward[j][i])+position0[j],3))
                            print(inp[2])
                            # print(thetaDes_floats)
                            priorStep[1] = x_values_forward
                            thetaDes_bytes = b""
                            for i in thetaDes_floats:
                                thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                            #DON'T SEND TO ROBOT WHILE TESTING. 
                            packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                            esp32.send(packet)
                            priorStep[0] = True
                        elif inp[2] == "DF":
                            #this is front foot forward but the reverse step, ergo: x_values_reversed.
                            thetaDes_floats = []
                            for i in range(knots):
                                for j in range((len(mids)-gripper_amt)):
                                    thetaDes_floats.append(round((x_values_reversed[j][i])+position0[j],3))
                            print(inp[2])
                            #print(thetaDes_floats)
                            priorStep[1] = x_values_reversed
                            thetaDes_bytes = b""
                            for i in thetaDes_floats:
                                thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                            #DON'T SEND TO ROBOT WHILE TESTING. 
                            packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                            esp32.send(packet)
                            priorStep[0] = True
                        else:
                            print("how?")
                            pass
                    elif inp[2] == "FU21" or inp[2] == "F21U":
                        #we go from tight, ie f100, to one space out, ie f200. B indicates the equivalent move with the backfoot.
                        frames = [
                            f000,
                            f213,
                            f212,
                            f200
                        ]
                        # if inp[2] == "BX12" or inp[2] == "BX21":
                        #     frames = [
                        #     f100,
                        #     f101,
                        #     f201+ np.array([-0.05,0,0,0,0,0]),
                        #     f200 + np.array([-0.08,0,0,0,0,0])
                        # ]

                        x_values_forward, x_values_reversed, x_values_forward_B, x_values_reversed_B = getTrajectories(frames,tk=[0,1,2,3])

                        if inp[2] == "FU21":
                            #step is x_values_forward
                            thetaDes_floats = []
                            for i in range(knots):
                                for j in range((len(mids)-gripper_amt)):
                                    thetaDes_floats.append(round((x_values_forward[j][i])+position0[j],3))
                            print("step FU21")
                            #print(thetaDes_floats)
                            priorStep[1] = x_values_forward
                            thetaDes_bytes = b""
                            for i in thetaDes_floats:
                                thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                            #DON'T SEND TO ROBOT WHILE TESTING. 
                            packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                            esp32.send(packet)
                            priorStep[0] = True
                        elif inp[2] == "F21U":
                            #this is front foot forward but the reverse step, ergo: x_values_reversed.
                            thetaDes_floats = []
                            for i in range(knots):
                                for j in range((len(mids)-gripper_amt)):
                                    thetaDes_floats.append(round((x_values_reversed[j][i])+position0[j],3))
                            print("step FX21")
                            print(thetaDes_floats)
                            priorStep[1] = x_values_reversed
                            thetaDes_bytes = b""
                            for i in thetaDes_floats:
                                thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                            #DON'T SEND TO ROBOT WHILE TESTING. 
                            packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                            esp32.send(packet)
                            priorStep[0] = True
                        
                    elif inp[2] == "S":
                        # print("a")
                        if len(inp) > 3:
                            repeats = int(inp[3])
                        else:
                            repeats = 1
                        with open('ant_paths/test2.npy', 'rb') as f:
                            steps = np.load(f)
                        path_length = steps.shape[0]
                        steps[:,4:] = -steps[:,4:]
                        # print(steps)
                        # print(path_length)
                        count = 0
                        with open('data.csv','w',newline='') as csvfile:
                            csv_writer = csv.writer(csvfile, delimiter=' ', quotechar='|', quoting=csv.QUOTE_MINIMAL)
                            for n in range(repeats):
                                print(n)
                                for l in range(path_length):
                                    if l == (path_length - 1):
                                        frames = [steps[l], steps[0],steps[0]]
                                    else:
                                        frames = [steps[l], steps[l+1],steps[l+1]]
                                    x_values_forward, x_values_reversed, x_values_forward_B, x_values_reversed_B = getTrajectories(frames,tk=[0,1,1.55])
                                    # print(l)
                                    thetaDes_floats = []
                                    for i in range(knots):
                                        for j in range((len(mids)-gripper_amt)):
                                            thetaDes_floats.append(round((x_values_forward[j][i])+position0[j],3))
                                    # print(thetaDes_floats)
                                    priorStep[1] = x_values_forward
                                    thetaDes_bytes = b""
                                    for i in thetaDes_floats:
                                        thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                                    #DON'T SEND TO ROBOT WHILE TESTING. 
                                    packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                                    esp32.send(packet)
                                    priorStep[0] = True
                                    # for t in range(1):
                                    #     euler = getEuler()
                                    #     accel = getAccel()
                                    #     print("E")
                                    #     print(euler)
                                    #     print("A")
                                    #     print(accel)
                                    #     count +=1
                                    # print("n")
                                    # print(n)
                                    # print(count)
                                for t in range((knots)*path_length):
                                    # print("E")
                                    message = esp32.recv()
                                    # print(message)
                                    euler = []
                                    for i in range(3):
                                        euler.append(round(struct.unpack("<f",message[(i*4):(i*4 + 4)])[0],3))
                                    # print(euler)
                                    # print(esp32.recv())
                                    # print("A")
                                    message = esp32.recv()
                                    accels = []
                                    for i in range(3):
                                        accels.append(round(struct.unpack("<f",message[(i*4):(i*4 + 4)])[0],3))
                                    # print(accels)
                                    feet = []
                                    for i in range(4):
                                        message = esp32.recv()
                                        feet.append(round(struct.unpack("<f",message)[0],3))
                                    new_row = euler + accels + feet
                                    for i in new_row:
                                        i  = str(i)
                                    csv_writer.writerow(new_row)
                            # print(esp32.recv())
                            # euler = getEuler()
                            # accel = getAccel()
                            # print("E")
                            # print(euler)
                            # print("A")
                            # print(accel)
                            # print(count)

                    elif inp[2] == "STAND":
                        frames = [
                            fd,
                            fd
                        ]
                        x_values_forward, x_values_reversed, x_values_forward_B, x_values_reversed_B = getTrajectories(frames,tk=[0,1])
                        
                        #step is x_values_forward
                        thetaDes_floats = []
                        for i in range(knots):
                            for j in range((len(mids)-gripper_amt)):
                                thetaDes_floats.append(round((x_values_forward[j][i])+position0[j],3))
                        print(inp[2])
                        # print(thetaDes_floats)
                        priorStep[1] = x_values_forward
                        thetaDes_bytes = b""
                        for i in thetaDes_floats:
                            thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                        #DON'T SEND TO ROBOT WHILE TESTING. 
                        packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                        esp32.send(packet)
                        priorStep[0] = True
                    
                    ###########
                    ### FIX ###
                    ###########
                    elif inp[2] == "FIX":
                        #DISABLED!!
                        if priorStep[0] == False:
                            print("no")
                        else:
                            x_values = priorStep[1]
                            thetaDes_floats=[]
                            temp_offset = np.zeros((len(ids)-gripper_amt))
                            if len(inp) > 3:
                                print("something")
                                changeAddr = int(int(inp[3])-9) #joint addresses start at 9
                                temp_offset[changeAddr] = float[inp[4]]
                                #inp[3] is address, inp[4] is offset amount
                            for i in range(knots-1,int(knots/4),-1):
                                for j in range((len(ids)-gripper_amt)):
                                    thetaDes_floats.append(round((x_values[j][i])+position0[j+1]+temp_offset[j],3))
                            #add the reversed to go back down. 
                            for i in range(int(knots/2),knots,1):
                                for j in range((len(ids)-gripper_amt)):
                                    thetaDes_floats.append(round((x_values[j][i])+position0[j+1]+temp_offset[j],3))
                            thetaDes_bytes = b""
                            for i in thetaDes_floats:
                                thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                            #DON'T SEND TO ROBOT WHILE TESTING. 
                            packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                            # esp32.send(packet)
                else:
                    print(":p")
                ############################
            else:
                print("invalid joint positions, please re-try")
        elif inp[1] == "U":
            #THIS HAS BEEN DISABLED -- CHECK IF IT's STILL VALID
            if priorStep[0] == True:
                x_values = priorStep[1]
                x_values_reversed = np.zeros(((len(ids)-gripper_amt),knots))
                for i in range((len(ids)-gripper_amt)):
                    x_values_reversed[i][:] = np.flip(x_values[i])
                
                thetaDes_floats = []
                for i in range(knots):
                    for j in range((len(ids)-gripper_amt)):
                        thetaDes_floats.append(1.5*round((-1*x_values_reversed[j][i])-position0[j+1],3))

                thetaDes_bytes = b""
                for i in thetaDes_floats:
                    thetaDes_bytes = thetaDes_bytes + struct.pack("@f", float(i))
                #DON'T SEND TO ROBOT WHILE TESTING. 
                packet = b"C"+b"M"+numActuatorM+MidsBytes+thetaDes_bytes
                # esp32.send(packet)  
                print(thetaDes_floats)
                priorStep[0] = False  
            else:
                print("no prior step")
        else:
            print("invalid cmd")
    elif inp[0] == "I":
        #this isn't for the servo version but I'm scared to remove it.
        newZero = input("input new absolute posiitons: " )
        newZero = newZero.split(":")
        for i in range(len(newZero)):
            position0[i] = float(newZero[i])
        print(position0)
    elif inp[0] == "Q":
        cont = False
        print("yeeting")
    else:
        print("whomst?")

    return cont

def initialize(inputs):
    inputs = inputs.translate({ord(c): None for c in string.whitespace})
    pass

while cont:
    inputs = input(
        "Single commands: CMD:Addr:DesVal or CMD:Addr. Multi-commands: C:CMD. Input: "
    )
    cont = parse_input(inputs, position0, priorStep)